//+------------------------------------------------------------------+
//|                                                mrMartinGale.mq4  |
//|                                                    Fedor Igumnov |
//|                                           igumnovfedor@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Fedor Igumnov"
#property link      "igumnovfedor@yandex.ru"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
extern bool      Martingale=true;   //  .
extern int       MartingaleDeep=8;  //   .
extern double    DefaultVolume=0.1; //   .      = DefaultVolume*2^MartingaleDeep;
extern double    StopLoss=100;      //  5  .
extern double    TakeProfit=1000;   //  5  .
                                    

double StartVolume;
int bbars;
int init()
{
StartVolume=DefaultVolume;
bbars=Bars;
   return(0);
  }

int deinit()
  {
//----

//----
   return(0);
  }
 
        int Pattern()
        {
            RefreshRates();
            int chastota[16];
            int PrivedQuoteGL[168];
            int three, two, one;
            int i;
            for (i=0;i<168;i++)
            {
            if (Open[i]>Open[i+1])
                PrivedQuoteGL[i]=1;
            if (Open[i]<Open[i+1])
                PrivedQuoteGL[i]=-1;
            }

            three = PrivedQuoteGL[2];
            two = PrivedQuoteGL[1];
            one = PrivedQuoteGL[0];
            for (i = 3; i < 168; i=i+4)
            {
                if ((PrivedQuoteGL[i - 3] == -1) && (PrivedQuoteGL[i - 2] == -1) && (PrivedQuoteGL[i - 1] == -1) && (PrivedQuoteGL[i] == -1))
                    chastota[0]++;
                if ((PrivedQuoteGL[i - 3] == -1) && (PrivedQuoteGL[i - 2] == -1) && (PrivedQuoteGL[i - 1] == -1) && (PrivedQuoteGL[i] == 1))
                    chastota[1]++;
                if ((PrivedQuoteGL[i - 3] == -1) && (PrivedQuoteGL[i - 2] == -1) && (PrivedQuoteGL[i - 1] == 1) && (PrivedQuoteGL[i] == -1))
                    chastota[2]++;
                if ((PrivedQuoteGL[i - 3] == -1) && (PrivedQuoteGL[i - 2] == -1) && (PrivedQuoteGL[i - 1] == 1) && (PrivedQuoteGL[i] == 1))
                    chastota[3]++;
                if ((PrivedQuoteGL[i - 3] == -1) && (PrivedQuoteGL[i - 2] == 1) && (PrivedQuoteGL[i - 1] == -1) && (PrivedQuoteGL[i] == -1))
                    chastota[4]++;
                if ((PrivedQuoteGL[i - 3] == -1) && (PrivedQuoteGL[i - 2] == 1) && (PrivedQuoteGL[i - 1] == -1) && (PrivedQuoteGL[i] == 1))
                    chastota[5]++;
                if ((PrivedQuoteGL[i - 3] == -1) && (PrivedQuoteGL[i - 2] == 1) && (PrivedQuoteGL[i - 1] == 1) && (PrivedQuoteGL[i] == -1))
                    chastota[6]++;
                if ((PrivedQuoteGL[i - 3] == -1) && (PrivedQuoteGL[i - 2] == 1) && (PrivedQuoteGL[i - 1] == 1) && (PrivedQuoteGL[i] == 1))
                    chastota[7]++;
                if ((PrivedQuoteGL[i - 3] == 1) && (PrivedQuoteGL[i - 2] == -1) && (PrivedQuoteGL[i - 1] == -1) && (PrivedQuoteGL[i] == -1))
                    chastota[8]++;
                if ((PrivedQuoteGL[i - 3] == 1) && (PrivedQuoteGL[i - 2] == -1) && (PrivedQuoteGL[i - 1] == -1) && (PrivedQuoteGL[i] == 1))
                    chastota[9]++;
                if ((PrivedQuoteGL[i - 3] == 1) && (PrivedQuoteGL[i - 2] == -1) && (PrivedQuoteGL[i - 1] == 1) && (PrivedQuoteGL[i] == -1))
                    chastota[10]++;
                if ((PrivedQuoteGL[i - 3] == 1) && (PrivedQuoteGL[i - 2] == -1) && (PrivedQuoteGL[i - 1] == 1) && (PrivedQuoteGL[i] == 1))
                    chastota[11]++;
                if ((PrivedQuoteGL[i - 3] == 1) && (PrivedQuoteGL[i - 2] == 1) && (PrivedQuoteGL[i - 1] == -1) && (PrivedQuoteGL[i] == -1))
                    chastota[12]++;
                if ((PrivedQuoteGL[i - 3] == 1) && (PrivedQuoteGL[i - 2] == 1) && (PrivedQuoteGL[i - 1] == -1) && (PrivedQuoteGL[i] == 1))
                    chastota[13]++;
                if ((PrivedQuoteGL[i - 3] == 1) && (PrivedQuoteGL[i - 2] == 1) && (PrivedQuoteGL[i - 1] == 1) && (PrivedQuoteGL[i] == -1))
                    chastota[14]++;
                if ((PrivedQuoteGL[i - 3] == 1) && (PrivedQuoteGL[i - 2] == -1) && (PrivedQuoteGL[i - 1] == 1) && (PrivedQuoteGL[i] == 1))
                    chastota[15]++;
            }

            if ((one==1) && (two==1) && (three==1))
            {
                if (chastota[14]>chastota[15])
                    return (-1);
                if (chastota[14]<chastota[15])
                    return (1);
            }
                        if ((one==1) && (two==1) && (three==-1))
            {
                if (chastota[12]>chastota[13])
                    return (-1);
                if (chastota[12]<chastota[13])
                    return (1);
            }
                        if ((one==1) && (two==-1) && (three==1))
            {
                if (chastota[10]>chastota[11])
                    return (-1);
                if (chastota[10]<chastota[11])
                    return (1);
            }
                        if ((one==1) && (two==-1) && (three==-1))
            {
                if (chastota[8]>chastota[9])
                    return (-1);
                if (chastota[8]<chastota[9])
                    return (1);
            }
                        if ((one==-1) && (two==1) && (three==1))
            {
                if (chastota[6]>chastota[7])
                    return (-1);
                if (chastota[6]<chastota[7])
                    return (1);
            }
                        if ((one==-1) && (two==1) && (three==-1))
            {
                if (chastota[4]>chastota[5])
                    return (-1);
                if (chastota[4]<chastota[5])
                    return (1);
            }
                        if ((one==-1) && (two==-1) && (three==1))
            {
                if (chastota[2]>chastota[3])
                    return (-1);
                if (chastota[2]<chastota[3])
                   return (1);
            }
                        if ((one==-1) && (two==-1) && (three==-1))
            {
                if (chastota[0]>chastota[1])
                   return (-1);
                if (chastota[0]<chastota[1])
                    return (1);
            }

         
        }
      int NewtonLawAC()
        {
            
           if (iAC(Symbol(),0,0)*Volume[1]<iAC(Symbol(),0,0)*Volume[2])
                 return (1);
           if (iAC(Symbol(),0,0)*Volume[1]>iAC(Symbol(),0,0)*Volume[2])
              return (-1);
         
        }
      int Trendy()
        {
            
           if (Close[1]<Open[1])
                 return (1);
           if (Close[1]>Open[1])
              return (-1);
         
        }
       int NewtonLawAD()
        {
            
           if (iAD(Symbol(),0,0)*Volume[1]<iAD(Symbol(),0,0)*Volume[2])
              return (1);
           if (iAD(Symbol(),0,0)*Volume[1]>iAD(Symbol(),0,0)*Volume[2])
              return (-1);
        }      
        int NewtonLaw()
        {   
           if (Close[1]*Volume[1]<Open[1]*Volume[2])
              return (1);
           if (Close[1]*Volume[1]>Open[1]*Volume[2])
              return (-1);        
        }  
        int EnergyConservation()
        {
        double H1,V1,g1,H2,V2,g2;
        V1=iRSI(NULL,0,14,PRICE_CLOSE,1);
        g1=iAC(Symbol(),0,1);
        H1=V1*V1/2*g1;
        V2=iRSI(NULL,0,14,PRICE_CLOSE,2);
        g2=iAC(Symbol(),0,2);       
        H2=V2*V2/2*g2;
        if (H1>H2)
        return(1);
          
        if (H1<H2)
        return(-1);      
        }
        int ImpulseConservation()
        {
        double m1,m2,V1,V2,U,m;
        m=Volume[0]+Volume[1];
        m1=Volume[1];
        m2=Volume[0];
        V1=iBullsPower(Symbol(),0,14,PRICE_CLOSE,0);
        U=(m1*V1+m2*V2)/m;
        if (U>0)
        return(1);
        if (U<0)
        return(-1);
        }
        int RSIm()
        {
             double r1; 
            
             double r2; 
              r1= iRSI(Symbol(),0,14,PRICE_CLOSE,1);
              r2= iRSI(Symbol(),0,14,PRICE_CLOSE,2);
             if (r2<29 && r1>29)
             return (1);
             if (r2>71 && r1<71) 
             return (-1);
        } 
           
        
int start()
  {
//----
   int ordert=666;
   if (bbars!=Bars)
   {
     bbars=Bars; 
    ordert=NewtonLaw()+Trendy()+Pattern()+RSIm()+NewtonLawAD()+NewtonLawAC()+EnergyConservation()+ImpulseConservation();
    
    }
    if (ordert==0)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
    OrderSend(Symbol(),OP_SELL,TakeProfit,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
    //OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==1)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
   // OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
    OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
      ordert=666;   
    }
        
    if (ordert==2)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
   // OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
    OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
      ordert=666;   
    }
    if (ordert==3)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
    //OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
     OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==4)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
    OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
   //OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==5)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
    OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
   // OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==6)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
    OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
    //OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==7)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
    OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
    //OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==8)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
    OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
   // OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==-1)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
    //OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
   OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==-2)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
   // OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
    OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==-3)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
    //OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
    OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==-4)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
   // OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
    OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==-5)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
    //OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
    OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
      
    }
        if (ordert==-6)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
   // OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
    OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==-7)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
   // OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
    OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
        if (ordert==-8)
    {  
    if (Martingale==true)
    {
    DefaultVolume=DefaultVolume*2;
    if (DefaultVolume>StartVolume*MathPow(2,MartingaleDeep))
    DefaultVolume=StartVolume;
    }  
    RefreshRates();
    //OrderSend(Symbol(),OP_BUY,DefaultVolume,Ask,20,Bid-StopLoss*Point,Ask+TakeProfit*Point);
    OrderSend(Symbol(),OP_SELL,DefaultVolume,Bid,20,Bid+StopLoss*Point,Ask-TakeProfit*Point);
      ordert=666;   
    }
                                                                        
//----
   return(0);
  }

//+---------